<script setup lang="ts">
import { useRoute } from 'vue-router';
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from '@ant-design-vue/pro-layout';
import { Form, message, Modal } from 'ant-design-vue/lib';
import { SizeType } from 'ant-design-vue/lib/config-provider';
import { MenuInfo } from 'ant-design-vue/lib/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/lib/table';
import { parseDateToStr } from '@/utils/date-utils';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import SoftwareHistory from './components/software-history.vue';

import {
  listNeSoftware,
  delNeSoftware,
  downloadNeSoftware,
  uploadNeSoftware,
  sendNeSoftware,
  runNeSoftware,
  backNeSoftware,
} from '@/api/configManage/softwareManage';
import { saveAs } from 'file-saver';
import useI18n from '@/hooks/useI18n';
import useNeInfoStore from '@/store/modules/neinfo';
import { FileType } from 'ant-design-vue/lib/upload/interface';
import { UploadRequestOption } from 'ant-design-vue/lib/vc-upload/interface';
const { t } = useI18n();
const route = useRoute();

/**路由标题 */
let title = ref<string>((route.meta.title as string) ?? '标题');

/**查询参数 */
let queryParams = reactive({
  /**网元类型 */
  neType: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neType: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('common.rowId'),
    dataIndex: 'id',
    align: 'center',
  },
  {
    title: t('views.configManage.softwareManage.neType'),
    dataIndex: 'neType',
    align: 'center',
  },
  {
    title: t('views.configManage.softwareManage.fileName'),
    dataIndex: 'fileName',
    align: 'center',
  },
  {
    title: t('views.configManage.softwareManage.version'),
    dataIndex: 'version',
    align: 'center',
  },
  {
    title: t('views.configManage.softwareManage.updateTime'),
    dataIndex: 'updateTime',
    align: 'center',
    customRender(opt) {
      if (!opt.value) return '';
      return parseDateToStr(opt.value);
    },
  },
  {
    title: t('views.configManage.softwareManage.description'),
    dataIndex: 'comment',
    align: 'center',
  },
  {
    title: t('common.operate'),
    key: 'id',
    align: 'center',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**文件对话框对象信息状态类型 */
type FileStateType = {
  /**是否下发或激活框 */
  visible: boolean;
  /**框类型 */
  visibleType: string;
  /**标题 */
  title: string;
  /**提示内容 */
  content: string;
  /**网元参数 */
  neOtions: Record<string, any>[];
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**文件对话框对象信息状态类型 */
let fileModalState: FileStateType = reactive({
  visible: false,
  visibleType: 'send',
  title: '下发激活回退',
  content: '',
  neOtions: [],
  from: {
    neId: undefined,
  },
  confirmLoading: false,
});

/**对话框内表单属性和校验规则 */
const fileModalStateFrom = Form.useForm(
  fileModalState.from,
  reactive({
    neId: [
      {
        required: true,
        message: t('views.configManage.softwareManage.neIdPlease'),
      },
    ],
  })
);

/**
 * 文件对话框弹出显示为 下发或激活
 */
function fnFileModalVisible(type: string | number, row: Record<string, any>) {
  if (type === 'send') {
    fileModalState.title = t('views.configManage.softwareManage.sendTitle');
    fileModalState.content = t(
      'views.configManage.softwareManage.sendContent',
      { num: row.id }
    );
  }
  if (type === 'run') {
    fileModalState.title = t('views.configManage.softwareManage.runTitle');
    fileModalState.content = t('views.configManage.softwareManage.runContent', {
      num: row.id,
    });
  }
  if (type === 'back') {
    fileModalState.title = t('views.configManage.softwareManage.backTitle');
    fileModalState.content = t(
      'views.configManage.softwareManage.backContent',
      { num: row.id }
    );
  }
  if (!fileModalState.content) {
    return;
  }

  fileModalState.from = Object.assign(fileModalState.from, row);
  // 过滤网元类型
  const neType = row.neType;
  let arr: Record<string, any>[] = [];
  for (const item of useNeInfoStore().getNeSelectOtions) {
    if (item.value === neType && Array.isArray(item.children)) {
      arr = item.children.concat();
      if (arr.length > 0) {
        fileModalState.from.neId = arr[0].neId;
      }
      break;
    }
  }
  fileModalState.neOtions = arr;
  fileModalState.visible = true;
  fileModalState.visibleType = type as string;
}

/**
 * 文件对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnFileModalOk() {
  fileModalStateFrom
    .validate()
    .then(e => {
      const from = toRaw(fileModalState.from);
      const type = fileModalState.visibleType;
      let fnType = null;
      if (type === 'send') {
        fnType = sendNeSoftware(from);
      }
      if (type === 'run') {
        fnType = runNeSoftware(from);
      }
      if (type === 'back') {
        fnType = backNeSoftware(from);
      }
      if (fnType === null) {
        return;
      }
      // 发送请求
      fileModalState.confirmLoading = true;
      const hide = message.loading({ content: t('common.loading') });
      fnType
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: fileModalState.title }),
              duration: 3,
            });
            fnFileModalCancel();
          } else {
            message.error({
              content: `${fileModalState.title} ${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          fileModalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 文件对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnFileModalCancel() {
  fileModalState.visible = false;
  fileModalState.visibleType = 'send';
  fileModalStateFrom.resetFields();
}

/**信息文件下载 */
function fnDownloadFile(row: Record<string, any>) {
  Modal.confirm({
    title: '提示',
    content: `确认下载记录编号为 【${row.id}】 的数据项文件?`,
    onOk() {
      const key = 'downloadNeSoftware';
      message.loading({ content: t('common.loading'), key });
      downloadNeSoftware(toRaw(row)).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: `已完成下载`,
            key,
            duration: 2,
          });
          saveAs(res.data, `user_${Date.now()}.xlsx`);
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**
 * 信息删除
 * @param row 记录编号ID
 */
function fnRecordDelete(row: Record<string, any>) {
  Modal.confirm({
    title: t('commont.tipTitle'),
    content: t('views.configManage.softwareManage.deleteTip', { num: row.id }),
    onOk() {
      const key = 'delNeSoftware';
      message.loading({ content: t('common.loading'), key });
      delNeSoftware(toRaw(row)).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', { msg: row.id }),
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key: key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**查询信息列表 */
function fnGetList() {
  if (tableState.loading) return;
  tableState.loading = true;
  listNeSoftware(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      tableState.data = res.rows;
    }
    tableState.loading = false;
  });
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  visibleByEdit: boolean;
  /**网元版本历史框是否显示 */
  visibleByHistory: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  visibleByEdit: false,
  visibleByHistory: false,
  title: '任务设置',
  from: {
    neType: undefined,
    version: '',
    comment: '',
    file: undefined,
    fileList: [],
    cms: undefined,
    cmsList: [],
  },
  confirmLoading: false,
});

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByEdit() {
  modalState.title = t('common.uploadText');
  modalState.visibleByEdit = true;
}

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    neType: [
      {
        required: true,
        message: t('views.configManage.softwareManage.neTypePlease'),
      },
    ],
    version: [
      {
        required: true,
        message: t('views.configManage.softwareManage.versionPlease'),
      },
    ],
    comment: [
      {
        required: true,
        message: t('views.configManage.softwareManage.updateCommentPlease'),
      },
    ],
    file: [
      {
        required: true,
        message: t('views.configManage.softwareManage.updateFilePlease'),
      },
    ],
  })
);

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  modalStateFrom
    .validate()
    .then(e => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.from);
      let formData = new FormData();
      formData.append('nf', from.neType);
      formData.append('version', from.version);
      formData.append('comment', from.comment);
      formData.append('file', from.file);
      formData.append('cms', from.cms);
      const hide = message.loading({ content: t('common.loading') });
      uploadNeSoftware(formData)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByEdit = false;
            modalStateFrom.resetFields();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
          // 获取列表数据
          fnGetList();
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.visibleByEdit = false;
  modalState.visibleByHistory = false;
  modalStateFrom.resetFields();
}

/**
 * 对话框弹出显示为 网元版本信息
 */
function fnModalVisibleByHistory() {
  modalState.visibleByHistory = true;
}

/**上传前检查或转换压缩 */
function fnBeforeUploadFile(file: FileType) {
  if (modalState.confirmLoading) return false;
  const fileName = file.name;
  const suff = fileName.substring(fileName.lastIndexOf('.'));
  if (!['.deb', '.rpm'].includes(suff)) {
    message.error('只支持上传文件格式（.deb、.rpm）', 3);
    return false;
  }
  const isLt60M = file.size / 1024 / 1024 > 60;
  if (!isLt60M) {
    message.error('有效软件文件大小应不小于 60MB', 3);
    return false;
  }
  return true;
}

/**上传文件 */
function fnUploadFile(up: UploadRequestOption) {
  // 改为完成状态
  const file = modalState.from.fileList[0];
  file.percent = 100;
  file.status = 'done';
  // 预置到表单
  modalState.from.file = up.file;
}

/**上传前检查或转换压缩 */
function fnBeforeUploadCms(file: FileType) {
  if (modalState.confirmLoading) return false;
  const fileName = file.name;
  const suff = fileName.substring(fileName.lastIndexOf('.'));
  if (!['.cms'].includes(suff)) {
    message.error('只支持上传文件格式（.deb、.rpm）', 3);
    return false;
  }
  const isLt2M = file.size / 1024 / 1024 < 2;
  if (!isLt2M) {
    message.error('有效校验文件大小应不大于 2MB', 3);
    return false;
  }
  return true;
}

/**上传文件 */
function fnUploadCms(up: UploadRequestOption) {
  // 改为完成状态
  const file = modalState.from.cmsList[0];
  file.percent = 100;
  file.status = 'done';
  // 预置到表单
  modalState.from.cms = up.file;
}

onMounted(() => {
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        if (res.data.length > 0) {
          const item = res.data[0];
          modalState.from.neType = item.neType;
        }
      } else {
        message.warning({
          content: `暂无网元列表数据`,
          duration: 2,
        });
      }
    });
  // 获取列表数据
  fnGetList();
});
</script>

<template>
  <PageContainer :title="title">
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.configManage.softwareManage.neType')"
              name="neType "
            >
              <a-auto-complete
                v-model:value="queryParams.neType"
                :options="useNeInfoStore().getNeSelectOtions"
                allow-clear
                :placeholder="
                  t('views.configManage.softwareManage.neTypePlease')
                "
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
            <template #icon><UploadOutlined /></template>
            {{ t('common.uploadText') }}
          </a-button>
          <a-button type="dashed" @click.prevent="fnModalVisibleByHistory()">
            <template #icon><HistoryOutlined /></template>
            {{ t('views.configManage.softwareManage.historyBtn') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown trigger="click" placement="bottomRight">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: true }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'id'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.downloadText') }}</template>
                <a-button type="link" @click.prevent="fnDownloadFile(record)">
                  <template #icon><DownloadOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button type="link" @click.prevent="fnRecordDelete(record)">
                  <template #icon><DeleteOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.moreText') }}</template>
                <a-dropdown
                  placement="bottomRight"
                  :trigger="['hover', 'click']"
                >
                  <a-button type="link">
                    <template #icon><EllipsisOutlined /> </template>
                  </a-button>
                  <template #overlay>
                    <a-menu
                      @click="({ key }:any) => fnFileModalVisible(key, record)"
                    >
                      <a-menu-item key="send">
                        <SendOutlined />
                        {{ t('views.configManage.softwareManage.sendBtn') }}
                      </a-menu-item>
                      <a-menu-item key="run">
                        <ThunderboltOutlined />
                        {{ t('views.configManage.softwareManage.runBtn') }}
                      </a-menu-item>
                      <a-menu-item key="back">
                        <UndoOutlined />
                        {{ t('views.configManage.softwareManage.backBtn') }}
                      </a-menu-item>
                    </a-menu>
                  </template>
                </a-dropdown>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 上传框 -->
    <a-modal
      width="800px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFrom"
        layout="horizontal"
        :label-col="{ span: 4 }"
      >
        <a-form-item
          :label="t('views.configManage.softwareManage.neType')"
          name="neType"
          v-bind="modalStateFrom.validateInfos.neType"
        >
          <a-select
            v-model:value="modalState.from.neType"
            :options="useNeInfoStore().getNeSelectOtions"
            :placeholder="t('views.configManage.softwareManage.neTypePlease')"
          >
          </a-select>
        </a-form-item>
        <a-form-item
          :label="t('views.configManage.softwareManage.version')"
          name="version"
          v-bind="modalStateFrom.validateInfos.version"
        >
          <a-input
            v-model:value="modalState.from.version"
            allow-clear
            :placeholder="t('views.configManage.softwareManage.versionPlease')"
          ></a-input>
        </a-form-item>
        <a-form-item
          :label="t('views.configManage.softwareManage.updateComment')"
          name="comment"
          v-bind="modalStateFrom.validateInfos.comment"
        >
          <a-textarea
            v-model:value="modalState.from.comment"
            :auto-size="{ minRows: 4, maxRows: 6 }"
            :maxlength="200"
            :show-count="true"
            :placeholder="
              t('views.configManage.softwareManage.updateCommentPlease')
            "
          />
        </a-form-item>
        <a-form-item
          :label="t('views.configManage.softwareManage.updateFile')"
          name="file"
          v-bind="modalStateFrom.validateInfos.file"
        >
          <a-upload
            name="file"
            v-model:file-list="modalState.from.fileList"
            accept=".rpm,.deb"
            list-type="text"
            :max-count="1"
            :show-upload-list="true"
            :before-upload="fnBeforeUploadFile"
            :custom-request="fnUploadFile"
          >
            <a-button type="default" :loading="modalState.confirmLoading">
              {{ t('views.configManage.softwareManage.selectFile') }}
            </a-button>
          </a-upload>
        </a-form-item>
        <a-form-item
          :label="t('views.configManage.softwareManage.verifyFile')"
          name="cms"
        >
          <a-upload
            name="cms"
            v-model:file-list="modalState.from.cmsList"
            accept=".cms"
            list-type="text"
            :max-count="1"
            :show-upload-list="true"
            :before-upload="fnBeforeUploadCms"
            :custom-request="fnUploadCms"
          >
            <a-button type="default" :loading="modalState.confirmLoading">
              {{ t('views.configManage.softwareManage.selectFile') }}
            </a-button>
          </a-upload>
        </a-form-item>
      </a-form>
    </a-modal>

    <!-- 上传激活历史 -->
    <SoftwareHistory
      :title="t('views.configManage.softwareManage.historyBtn')"
      v-model:visible="modalState.visibleByHistory"
      @cancel="fnModalCancel"
    />

    <!-- 文件框 下发激活回退 -->
    <a-modal
      width="600px"
      :keyboard="false"
      :mask-closable="false"
      :visible="fileModalState.visible"
      :title="fileModalState.title"
      :confirm-loading="fileModalState.confirmLoading"
      @ok="fnFileModalOk"
      @cancel="fnFileModalCancel"
    >
      <a-form name="fileModalState" layout="horizontal">
        <a-form-item name="content">
          <QuestionCircleOutlined class="file-model__icon" />
          <span class="file-model__tip">
            {{ fileModalState.content }}
          </span>
        </a-form-item>
        <a-form-item
          :label="t('views.configManage.softwareManage.neId')"
          name="neId"
          v-bind="fileModalStateFrom.validateInfos.neId"
        >
          <a-select
            v-model:value="fileModalState.from.neId"
            :options="fileModalState.neOtions"
            :placeholder="t('views.configManage.softwareManage.neIdPlease')"
          />
        </a-form-item>
      </a-form>
    </a-modal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}

.file-model {
  &__icon {
    color: var(--ant-warning-color);
    margin-right: 16px;
    font-size: 22px;
  }
  &__tip {
    overflow: hidden;
    color: #000000d9;
    font-weight: 500;
    font-size: 16px;
    line-height: 1.4;
  }
}
</style>
